<table class="form-table">
	<tbody>
		<tr>
			<th scope="row"><label for="easyazon-default-search-locale"><?php _e('Default Search Locale'); ?></label></th>
			<td>
				<select name="easyazon[default-search-locale]" id="easyazon-default-search-locale">
					<?php foreach($locale_keys as $locale_key) { ?>
					<option <?php selected($locale_key, $settings['default-search-locale']); ?> value="<?php esc_attr_e($locale_key); ?>"><?php esc_html_e(Amazon_API::get_locale_name($locale_key)); ?></option>
					<?php } ?>
				</select>
			</td>
		</tr>
		<tr>
			<th scope="row"><label for="easyazon-default-search-index"><?php _e('Default Search Index'); ?></label></th>
			<td>
				<select name="easyazon[default-search-index]" id="easyazon-default-search-index">
					<?php foreach($locale_keys as $locale_key) { foreach(Amazon_API::get_locale_search_indices($locale_key) as $search_index) { ?>
					<option <?php selected($locale_key . $search_index, $settings['default-search-locale'] . $settings['default-search-index']); ?> class="<?php esc_attr_e($locale_key); ?>" value="<?php esc_attr_e($search_index); ?>"><?php esc_html_e(Amazon_API::get_search_index_nice_name($search_index)); ?></option>
					<?php } } ?>
				</select>
			</td>
		</tr>
		<tr>
			<th scope="row"><?php _e('Enabled Content Types'); ?></th>
			<td>
				<ul>
					<?php foreach(get_post_types(array('show_ui' => true), 'objects') as $type) { ?>
					<li>
						<label>
							<input type="checkbox" <?php checked($settings['post-types'][$type->name], 'yes'); ?> name="easyazon[post-types][<?php esc_attr_e($type->name); ?>]" value="yes" />
							<?php esc_html_e($type->labels->name); ?>
						</label>
					</li>
					<?php } ?>
				</ul>
				<small><?php _e('Check the boxes next to the content types you wish to use'); ?></small>
			</td>
		</tr>
	</tbody>
</table>